#include <iostream.h>
#include <stdlib.h>

/*
 * Call the (efficient) library sorting function to sort an
 * array of floats. The array could be of any type, such as
 * a structure you have defined. Note we pass a function we
 * have defined to qsort, and qsort calls our function to 
 * decide the relationship between two elements: <, > or ==.
 * Our function should return -1 for <, 1 for > or 0 if the
 * two elements are considered the same.
 */

// no need to prototype because we have written it
// before it is called so the compiler knows what it is
int myCmp(const void* e1, const void* e2)
{
  // need to 'cast' e1 and e2 to be float pointers
  float* fe1 = (float*)e1;
  float* fe2 = (float*)e2;

  // use temp variables to function easier to read
  float temp1 = *fe1;
  float temp2 = *fe2;

  // sort to give ascending order
  if (temp1 < temp2) {
    return -1;
  }
  else if (temp1 > temp2) {
    return 1;
  }

  return 0;
}

int main(int argc, char* argv[])
{
  int i;
  float data[10], originalData[10];

  // load array in decesending order
  for (i=0; i<10; i++) {
    data[i] = originalData[i] = float(9 - i);
  }

  qsort(data, 10, sizeof(float), myCmp);

  for (i=0; i<10; i++) {
    cout << originalData[i] << "\t" << data[i] << "\n";
  }

  return 0;
}
